OpenTTD

Data Structures | Typedefs | Functions | Variables
language.h File Reference

Information about languages and their files. More...

`#include "core/smallvec_type.hpp"`
`#include <unicode/coll.h>`
`#include "strings_type.h"`

Go to the source code of this file.

## Data Structures
struct | LanguagePackHeader
| Header of a language file. More...
struct | LanguageMetadata
| Metadata about a single language. More...

## Typedefs
typedef SmallVector< LanguageMetadata, 4 > | LanguageList
| Type for the list of language meta data. More...

## Functions
| assert_compile (sizeof(LanguagePackHeader) % 4==0)
| Make sure the size is right. More...
bool | ReadLanguagePack (const LanguageMetadata *lang)
| Read a particular language. More...
const LanguageMetadata * | GetLanguage (byte newgrflangid)
| Get the language with the given NewGRF language ID. More...

## Variables
static const uint8 | CASE_GENDER_LEN = 16
| The (maximum) length of a case/gender string.
static const uint8 | MAX_NUM_GENDERS = 8
| Maximum number of supported genders.
static const uint8 | MAX_NUM_CASES = 16
| Maximum number of supported cases.
LanguageList | _languages
| The actual list of language meta data. More...
const LanguageMetadata * | _current_language
| The currently loaded language. More...
Collator * | _current_collator
| Collator for the language currently in use.

## Detailed Description

Information about languages and their files.

Definition in file language.h.

## Typedef Documentation

## ◆ LanguageList

typedef SmallVector<LanguageMetadata, 4> LanguageList

Type for the list of language meta data.

Definition at line 99 of file language.h.

## Function Documentation

## ◆ assert_compile()

assert_compile | ( | sizeof(LanguagePackHeader) % | 4 = `=0` | ) |

Make sure the size is right.

Referenced by LanguagePackHeader::GetCaseIndex().

## ◆ GetLanguage()

const LanguageMetadata* GetLanguage | ( | byte | newgrflangid | ) |

Get the language with the given NewGRF language ID.

Parameters

  newgrflangid | NewGRF languages ID to check.

Returns
  The language's metadata, or NULL if it is not known.

Definition at line 1875 of file strings.cpp.

References SmallVector< T, S >::Begin(), and SmallVector< T, S >::End().

## ◆ ReadLanguagePack()

bool ReadLanguagePack | ( | const LanguageMetadata * | lang | ) |

Read a particular language.

Parameters

  lang | The metadata about the language.

Returns
  Whether the loading went okay or not.

Definition at line 1716 of file strings.cpp.

References StringParameters::data, LanguageMetadata::file, free(), LanguagePackHeader::IsValid(), LanguagePackHeader::offsets, ReadFileToMem(), and TEXT_TAB_END.

## Variable Documentation

## ◆ _current_language

const LanguageMetadata* _current_language

The currently loaded language.

Definition at line 50 of file strings.cpp.

Referenced by SelectGameWindow::UpdateWidgetSize().

## ◆ _languages

LanguageList _languages

The actual list of language meta data.

Definition at line 49 of file strings.cpp.